//#include "config.h"
#include <X11/Xlib.h>
#include <X11/extensions/XShm.h>
#include <X11/Xutil.h>
#include <X11/extensions/shape.h>
#include <X11/Xatom.h>
#include <X11/Xos.h>
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <math.h>

/*
#include <sys/time.h>
#include "common.h"
#include "image.h"
#include "rend.h"
#include "rgba.h"
#include "ximage.h"
#include "color.h"
 */
#include "Imlib2.h"


Display            *disp;
Window              win;
Window              win2;
Window              win3;
Visual             *vis;
Colormap            cm;
int                 depth;
XSetWindowAttributes attr;
char *appToRun;
int i3;
int mytoggle = 0;

int ReplaceStr(char *sSrc, char *sMatchStr, char *sReplaceStr)
{
   int  StringLen;
   char caNewString[1024];
   char *FindPos = strstr(sSrc, sMatchStr);
   if( (!FindPos) || (!sMatchStr) )
      return -1;
   while( FindPos )
   {
      memset(caNewString, 0, sizeof(caNewString));
      StringLen = FindPos - sSrc;
      strncpy(caNewString, sSrc, StringLen);
      strcat(caNewString, sReplaceStr);
      strcat(caNewString, FindPos + strlen(sMatchStr));
      strcpy(sSrc, caNewString);
      FindPos = strstr(sSrc, sMatchStr);
   }

   return 0;
}

void showwin3(int screenX,int screenY,int screenWidth)
{
  char text[1024];  
  Imlib_Image         buffer;
  int text_w,text_h;
  Imlib_Font          font;

        buffer = imlib_create_image(1000, 30);  
        font = imlib_load_font("Vera/11");
        imlib_context_set_font(font);
        imlib_context_set_color(0, 0, 0, 255);
        time_t now_time;
        now_time=time(0);
        if (i3==1)
        {
          strftime(text, sizeof(text), "%H:%M",localtime(&now_time) );
          i3=0;
        } else {
          strftime(text, sizeof(text), "%H %M",localtime(&now_time) );
          i3=1;
        }
        imlib_get_text_size(text, &text_w, &text_h);
        win3=XCreateWindow(disp,DefaultRootWindow(disp),screenX+screenWidth+1,screenY,text_w+10,text_h+4,0,0,0,CopyFromParent,CWBackingStore|CWOverrideRedirect|CWEventMask,&attr);
        XRaiseWindow(disp,win3);
        XMapWindow(disp, win3);
        imlib_context_set_drawable(win3); 
//        imlib_context_set_image(buffer);
           /* draw the range */
        imlib_context_set_image(buffer);
        imlib_image_fill_color_range_rectangle(0,0, text_w*4, text_h*2,-45.0);
           /* free it */
      //     imlib_free_color_range();
        imlib_context_set_image(buffer);
        imlib_render_image_on_drawable(0, 0); 
        imlib_context_set_image(buffer);
        imlib_context_set_font(font);
        imlib_context_set_color(0, 0, 0, 255);
        imlib_text_draw(5,2,text);
        /* set the buffer image as our current image */
        imlib_context_set_image(buffer);
        imlib_context_set_drawable(win3); 
        imlib_render_image_on_drawable(0, 0); 
        imlib_context_set_image(buffer);
        imlib_free_image();
        imlib_context_set_font(font);
        imlib_free_font();


}

void showwin2(int screenX,int screenY,int screenWidth)
{
  char text[1024];  
  Imlib_Image         buffer;
  int text_w,text_h;
  Imlib_Font          font;
  int i;
        mytoggle = 1;
        buffer = imlib_create_image(1000, 200);  
        font = imlib_load_font("Vera/9");
        imlib_context_set_font(font);
        imlib_context_set_color(0, 0, 0, 255);
        imlib_get_text_size(text, &text_w, &text_h);
        win2=XCreateWindow(disp,DefaultRootWindow(disp),screenX+screenWidth+4,screenY,600,200,0,0,0,CopyFromParent,CWBackingStore|CWOverrideRedirect|CWEventMask,&attr);
        XRaiseWindow(disp,win2);
        XMapWindow(disp, win2);
        imlib_context_set_drawable(win2); 
//        imlib_context_set_image(buffer);
           /* draw the range */
        imlib_context_set_image(buffer);
        imlib_image_fill_color_range_rectangle(0,0, 1200, 400,-45.0);
           /* free it */
      //     imlib_free_color_range();
        imlib_context_set_image(buffer);
        imlib_render_image_on_drawable(0, 0); 
        imlib_context_set_image(buffer);
        imlib_context_set_font(font);
        imlib_context_set_color(0, 0, 0, 255);

        time_t now_time;
        now_time=time(0);
        strftime(text, sizeof(text), "%Y年%m月%d日 星期(%w)",localtime(&now_time) );
        imlib_text_draw(160,2,text);
        system("top -b -n1 >./top.txt");
        /* set the buffer image as our current image */
        FILE *freeNum;
        freeNum=fopen("./top.txt","r");
        if ( freeNum==NULL)
          printf("error on open top.txt\n"); 
        fgets(text,1024,freeNum);
        i=1;
        while (! feof(freeNum))
        {
          ReplaceStr(text,"top -","时间：");
          ReplaceStr(text,"up ",", 已开机：");
          ReplaceStr(text," users"," 个用户");
          ReplaceStr(text," user"," 个用户");
          ReplaceStr(text,"load average:","系统负载：");
          ReplaceStr(text,"Tasks:","进程：");
          ReplaceStr(text,"total","总数中");
          ReplaceStr(text,"running","个正在运行");
          ReplaceStr(text,"sleeping","个在休眠");
          ReplaceStr(text,"stopped","个已经停止");
          ReplaceStr(text,"zombie","个已经僵死");
          ReplaceStr(text,"Mem:","内存：");
          ReplaceStr(text,"total","总数中");
          ReplaceStr(text,"used","已使用");
          ReplaceStr(text,"free","空闲");
          ReplaceStr(text,"buffers","缓冲");
          ReplaceStr(text,"Swap:","交换内存：");
          ReplaceStr(text,"cached","缓存");
          ReplaceStr(text,"us"," 被用户占用");
          ReplaceStr(text,"sy"," 被系统占用");
          ReplaceStr(text,"id"," 空闲");
          imlib_text_draw(5,i*15+2,text);
          i=i+1;
          fgets(text,1024,freeNum);
          
        }
        imlib_context_set_image(buffer);
        imlib_context_set_drawable(win2); 
        imlib_render_image_on_drawable(0, 0); 
        imlib_context_set_image(buffer);
        imlib_free_image();
        imlib_context_set_font(font);
        imlib_free_font();

}

int main(int argc, char **argv)
{
  int                 w, h, x, y;
  Imlib_Image         im_bg = NULL;
  XEvent              ev;
  const char         *display_name = getenv("DISPLAY");
  Imlib_Image         buffer;
  Imlib_Image         back;
  Imlib_Image         bigback;
  Imlib_Font          font;
  char                text[4096];
  Imlib_Color_Range   range;
  int  text_w, text_h;
  if (display_name == NULL)
    display_name = ":0";
  disp = XOpenDisplay(display_name);
  if (disp == NULL)
  {
    fprintf(stderr, "Can't open display %s\n", display_name);
    return 1;
  }

  int screen=DefaultScreen(disp);
  int screenWidth=0;
  screenWidth=XDisplayWidth(disp,screen);
  screenWidth=64;
  int screenHeight;
  screenHeight=64;
  int screenX=10;
  int screenY=10;
  int lowerraise=0;
  char group[1024];
  char picname[1024];
  char title[1024];
  int xl=0;
  int yl=0;
  int store=0;
  int autohidemainbutton=0;
  int MouseMoveOpenSubIcon=0;
  char home[1024];
  int showclock;
  int s_g;
  sprintf(home,"%s",getenv("HOME"));

  char submenue[1000];
  char ch2[1024];
//----arguments x y width height lower/raise(0/1) picture hidemode
  if ( argc != 11 )
  {
    printf("usage: iconrun1 x y width height lower/raise(0/1) group image autohidemainbutton(0/1/2) MouseMoveOpenSubIcon(0/1/2) showclock(0/1)\n");
    return 1;
  }
  printf("ok\n");
  sscanf(argv[1], "%d", &screenX);
  sscanf(argv[2], "%d", &screenY);
  sscanf(argv[3], "%d", &screenWidth);
  sscanf(argv[4], "%d", &screenHeight);
  sscanf(argv[5], "%d", &lowerraise);
  sscanf(argv[6], "%d", &group);
  sscanf(argv[7], "%s", &picname);
  sscanf(argv[8], "%d", &autohidemainbutton);
  sscanf(argv[9], "%d", &MouseMoveOpenSubIcon);
  sscanf(argv[10], "%d", &showclock);
  
  vis = DefaultVisual(disp, DefaultScreen(disp));
  depth = DefaultDepth(disp, DefaultScreen(disp));
  cm = DefaultColormap(disp, DefaultScreen(disp));
        // text
  range = imlib_create_color_range();
  imlib_context_set_color_range(range);
  imlib_context_set_color(255, 255, 255, 255);
  imlib_add_color_to_color_range(0);
  /* add an orange color, semi-transparent 10 units from the first */
  imlib_context_set_color(255, 200, 10, 255);
  imlib_add_color_to_color_range(10);
  /* add black, fully transparent at the end 20 units away */
  imlib_context_set_color(70, 0, 0, 255);
  imlib_add_color_to_color_range(20);

  attr.override_redirect=True;
 //win=XCreateWindow(disp,DefaultRootWindow(disp),screenX,screenY,screenWidth,screenHeight,0,CopyFromParent,InputOutput,CopyFromParent,CWBackingStore|CWOverrideRedirect|CWEventMask|CWBorderPixel|CWSaveUnder|CWColormap|CWBackPixel,&attr);
  win=XCreateWindow(disp,DefaultRootWindow(disp),screenX,screenY,screenWidth,screenHeight,0,0,0,CopyFromParent,CWBackingStore|CWOverrideRedirect|CWEventMask,&attr);
//   win =  XCreateSimpleWindow(disp, DefaultRootWindow(disp), 0, 0, 100, 100, 0, 0, 0);
  XSelectInput(disp, win, ButtonPressMask | ButtonReleaseMask | ButtonMotionMask | PointerMotionMask | ExposureMask | EnterWindowMask | LeaveWindowMask);
  XMapWindow(disp, win);

  if(lowerraise==0)
     XLowerWindow(disp,win);
  if(lowerraise==1)
     XRaiseWindow(disp,win);
  if (autohidemainbutton==1)
     XMoveWindow(disp,win,-screenWidth+2 , screenY);
  if (autohidemainbutton==2)
     XMoveWindow(disp,win,-screenWidth/2 , screenY);

   /**
    * Start rendering
    */
   /**
    * Start rendering
    */

  imlib_context_set_display(disp);
  imlib_context_set_visual(vis);
  imlib_context_set_colormap(cm);
  imlib_context_set_drawable(win);
  imlib_context_set_dither(1);
  imlib_context_set_blend(0);
  imlib_context_set_color_modifier(NULL);

//--
  w=screenWidth;
  h=screenHeight;
  back = imlib_load_image("../pics/background.jpg");
  imlib_context_set_image(back);
  buffer = imlib_create_cropped_scaled_image(0, 0,imlib_image_get_width() ,imlib_image_get_height() , w , h);
  im_bg = imlib_load_image(picname);
  XMapWindow(disp, win);
  imlib_context_set_image(im_bg);

  int is=imlib_image_get_width();
  int ih=imlib_image_get_height();
  int d1=screenWidth-is;
  d1=d1/2;
  int d2=screenHeight-ih;
  d2=d2/2;

  imlib_context_set_image(im_bg);
  imlib_context_set_blend(1);

  imlib_context_set_image(back);
  imlib_render_image_on_drawable(0, 0);
  imlib_context_set_image(im_bg);
  imlib_render_image_on_drawable_at_size(d1-1, d2-1,is+2,ih+2);
  bigback=imlib_create_image_from_drawable( 0,0,0,w,h,1);

  imlib_context_set_image(back);
  imlib_render_image_on_drawable(0, 0);
  imlib_context_set_image(im_bg);

  imlib_render_image_on_drawable(d1, d2);
  back=imlib_create_image_from_drawable( 0,0,0,w,h,1);

  XResizeWindow(disp, win, w, h);
  XSync(disp, False);
  x = -9999;
  y = -9999;
  x = -screenWidth/2;
  y = -screenHeight/2;
  int i=1;
  i3=1;
  int xfd = ConnectionNumber(disp);
  fd_set rfds;
  timeval now, tm,LastTime;
  long ticks;
  gettimeofday(&LastTime, 0);
  while (1)
  {
//--
    if (XPending(disp))
    {
      XNextEvent(disp, &ev);
      switch (ev.type)
      {
      case Expose:
        break;
      case MotionNotify:
        x = ev.xmotion.x;
        y = ev.xmotion.y;
        break;
      default:
        break;
      case EnterNotify:		
        showwin2(screenX , screenY,screenWidth);
        system("killall iconrun3 2>/dev/null");	
        imlib_context_set_image(im_bg);
        imlib_context_set_drawable(win);
        XMoveWindow(disp,win,screenX , screenY);
        imlib_context_set_display(disp);
        imlib_context_set_visual(vis);
        imlib_context_set_colormap(cm);
        imlib_context_set_drawable(win);
        imlib_context_set_dither(1);
        imlib_context_set_blend(0);
        imlib_context_set_color_modifier(NULL);
        w=screenWidth;
        h=screenHeight;
        back = imlib_load_image("../pics/background.jpg");
        imlib_context_set_image(back);
        buffer = imlib_create_cropped_scaled_image(0, 0,imlib_image_get_width() ,imlib_image_get_height() , w , h);
        im_bg = imlib_load_image(picname);
        XMapWindow(disp, win);
        imlib_context_set_image(im_bg);
        is=imlib_image_get_width();
        ih=imlib_image_get_height();
        d1=screenWidth-is;
        d1=d1/2;
        d2=screenHeight-ih;
        d2=d2/2;
        imlib_context_set_image(im_bg);
        imlib_context_set_blend(1);
        imlib_context_set_image(back);
        imlib_render_image_on_drawable(0, 0);
        imlib_context_set_image(im_bg);
        imlib_render_image_on_drawable_at_size(d1-1, d2-1,is+2,ih+2);
        bigback=imlib_create_image_from_drawable( 0,0,0,w,h,1);
        imlib_context_set_image(back);
        imlib_render_image_on_drawable(0, 0);
        imlib_context_set_image(im_bg);
        imlib_render_image_on_drawable(d1, d2);
        back=imlib_create_image_from_drawable( 0,0,0,w,h,1);
        XResizeWindow(disp, win, w, h);
        system("killall iconrun3 2>/dev/null");	
        if ((store==0) and (MouseMoveOpenSubIcon==2))
        {
          sprintf(submenue,"./iconmenu START %s",home);
          system(submenue);
          store=1;
        }
        if (MouseMoveOpenSubIcon==1)
        {
          system("killall iconrun2 2>/dev/null");
          sprintf(submenue,"./iconmenu START %s",home);
          system(submenue);
        }
        if ((autohidemainbutton==1) or (autohidemainbutton==2))
          XMoveWindow(disp,win,screenX , screenY);
        break;
      case LeaveNotify:		
            x = -screenWidth/2;
            y = -screenHeight/2;		
            mytoggle = 0;
            XDestroyWindow(disp,win2);	
            if(autohidemainbutton==1)
              XMoveWindow(disp,win,-screenWidth+2 , screenY);
            if(autohidemainbutton==2)
              XMoveWindow(disp,win,-screenWidth/2 , screenY);
            break;
          case ButtonPress:				
            if(ev.xbutton.button==1)
            {
              if((store==1) and (MouseMoveOpenSubIcon==0))
              {
                system("killall iconrun2 2>/dev/null");	
                system("killall iconrun3 2>/dev/null");	
                store=0;
                break;
              } else {
                sprintf(submenue,"./iconmenu START %s",home);
                system(submenue);
                store=1;
              }  
            }
            if(ev.xbutton.button==3)
            {
                                    /* if we click anywhere in the window, exit */
              system("killall iconrun3 2>/dev/null");	
              system("killall iconrun2 2>/dev/null");	
              sprintf(submenue,"./iconmenu INIT %s",home);
              system(submenue);
              exit(0);
              break;
            }
            break;
         }
      } else {
        //display 是由 XopenDisplay 返回的 Display *
        FD_ZERO(&rfds);
        FD_SET(xfd, &rfds);
        gettimeofday(&now, 0);
//LastTime 是 timeval 类型的变量,保存上次时间
//ticks 的单位是毫秒 millisecond
        if (showclock==1)
        {
          ticks=(now.tv_sec-LastTime.tv_sec)*1000+(now.tv_usec-LastTime.tv_usec)/1000;
          if (ticks>=1000)
          {
            gettimeofday(&LastTime, 0);
            showwin3(screenX,screenY,screenWidth);
          }
        }
//如果到期则调用有关函数
//select 等待 100 毫秒
        tm.tv_sec=0l;
        tm.tv_usec=100000l;
        select(xfd + 1, &rfds, 0, 0, &tm);
    } /* End else*/

    if(mytoggle == 1)
    {
      imlib_context_set_image(bigback);
      xl=x-24;
      yl=y-24;
    }else{
      imlib_context_set_image(back);
      xl=x-10;
      yl=y-10;
    }
  }
  Imlib_Image        temp, temp2;
  temp = imlib_clone_image();
  imlib_context_set_image(temp);
  imlib_apply_filter
  ("bump_map_point(x=[],y=[],map=""blend.jpg);", &xl, &yl);
  imlib_context_set_image(back);
  imlib_render_image_on_drawable(0, 0);
  temp2 = im_bg;
  im_bg = temp;
  imlib_context_set_image(im_bg);
  imlib_context_set_blend(1);
  imlib_render_image_on_drawable(0, 0);
  im_bg = temp2;
  imlib_context_set_image(temp);
  imlib_free_image();
  return 0;
}

